
def get_dict(code):
    rules = {}
    for i in range(8):
        if code % 2 == 1:
            rules[i] = "X"
        else:
            rules[i] = "."
        code //= 2
    return rules


def decode(text):
    res = 0
    for char in text:
        res *= 2
        res += 1 if char == "X" else 0
    return res


def main():
    inputs = input().split(" ")
    rules = get_dict(int(inputs[0]))
    gen = input()
    for _ in range(int(inputs[1])):
        temp = ""
        for i in range(len(gen)):
            if i == 0:
                if i + 1 == len(gen):
                    temp += rules[decode("." + gen + ".")]
                    continue
                temp += rules[decode("." + gen[:2])]
                continue
            if i + 1 == len(gen):
                temp += rules[decode(gen[-2:] + ".")]
                continue
            temp += rules[decode(gen[i-1: i+2])]
        gen = temp
        print(gen)


main()
