def add_con(lab1, lab2, lab_cons):
    lab_cons[lab1].append(lab2)
    lab_cons[lab2].append(lab1)

def add_desks(lab, c_desks, lab_cons, av_desks):
    av_desks[lab] += c_desks
    for alab in lab_cons[lab]:
        av_desks[alab] += c_desks

def add_mons(lab, c_mons, lab_cons, av_mons):
    av_mons[lab] += c_mons
    for alab in lab_cons[lab]:
        av_mons[alab] += c_mons

def compare(av_mons, av_desks):
    if av_mons > av_desks:
        print("monitors")
    if av_mons == av_desks:
        print("same")
    if av_mons < av_desks:
        print("desks")

def main():
    lab_cons = {}

    nmq = input().split(" ")
    N = int(nmq[0])
    M = int(nmq[1])
    Q = int(nmq[2])

    av_desks = [0 for i in range(N + 1)]
    av_mons = [0 for i in range(N + 1)]

    for i in range(1, N + 1):
        lab_cons[i] = []

    desks = list(map(int, input().split(" ")))
    mons = list(map(int, input().split(" ")))

    for i in range(M):
        labs = input().split(" ")
        add_con(int(labs[0]), int(labs[1]), lab_cons)

    for i in range(1, N + 1):
        add_desks(i, desks[i - 1], lab_cons, av_desks)
        add_mons(i, mons[i - 1], lab_cons, av_mons)

    for _ in range(Q):
        line = input().split(" ")
        if line[0] == "add":
            if line[2] == "desk":
                add_desks(int(line[3]), int(line[1]), lab_cons, av_desks)
            if line[2] == "monitor":
                add_mons(int(line[3]), int(line[1]), lab_cons, av_mons)
        if line[0] == "check":
            lab = int(line[1])
            compare(av_mons[lab], av_desks[lab])

main()

